package baecon.devgames.events;

import baecon.devgames.database.modelupdate.IModelUpdate;

public abstract class PushDoneEvent {

    /**
     * The id of this update, generated by the database.
     */
    public final long updateId;

    /**
     * The local database id of the model where this update is related to.
     */
    public final long localModelId;

    public PushDoneEvent(final IModelUpdate update) {
        this.updateId = update.getId();
        this.localModelId = update.getLocalId();
    }

    public PushDoneEvent(long updateId, long localModelId) {
        this.updateId = updateId;
        this.localModelId = localModelId;
    }

    @Override
    public String toString() {
        return getClass().getSimpleName() +
                "{" +
                "updateId=" + updateId +
                ", localModelId=" + localModelId +
                '}';
    }
}